package me.hammerle.snuviengine.api;

public final class GamepadBinding
{
    private final String name;
    private final int mapping;
    
    private boolean isDown = false;
    private int time = 0;
    private boolean isReleased = false;
    
    protected GamepadBinding(String name, int mapping)
    {
        this.name = name;
        this.mapping = mapping;
    }
    
    public String getName()
    {
        return name;
    }

    protected int getMapping()
    {
        return mapping;
    }
    
    protected void tick(boolean isDown)
    {
        if(isReleased)
        {
            isReleased = false;
            time = 0;
        }
        if(this.isDown && !isDown)
        {
            isReleased = true;
            time++;
        }
        this.isDown = isDown;
        if(isDown)
        {
            time++;
        }
    }
    
    public boolean isDown()
    {
        return isDown;
    }

    public boolean isReleased()
    {
        return isReleased;
    }

    public int getTime()
    {
        return time;
    }

    public void setTime(int time)
    {
        this.time = time;
    }
}